
_main:

;UPL.c,34 :: 		void main(void)
;UPL.c,36 :: 		setup();           //Setup the micro for operation
	CALL       UPL_setup+0
;UPL.c,37 :: 		test_supply();     //Check supply voltage and choose convention
	CALL       UPL_test_supply+0
;UPL.c,38 :: 		test_display();    //Check display
	CALL       UPL_test_display+0
;UPL.c,40 :: 		for(;;)             //Infinite loop
L_main0:
;UPL.c,42 :: 		check_logic();   //Test logic level at logic input terminal
	CALL       _check_logic+0
;UPL.c,43 :: 		}
	GOTO       L_main0
;UPL.c,44 :: 		}
L_end_main:
	GOTO       $+0
; end of _main

UPL_setup:

;UPL.c,47 :: 		static void setup(void)
;UPL.c,50 :: 		TRISIO5_bit = 0;
	BCF        TRISIO5_bit+0, 5
;UPL.c,51 :: 		TRISIO4_bit = 0;
	BCF        TRISIO4_bit+0, 4
;UPL.c,52 :: 		TRISIO3_bit = 1;
	BSF        TRISIO3_bit+0, 3
;UPL.c,53 :: 		TRISIO2_bit = 0;
	BCF        TRISIO2_bit+0, 2
;UPL.c,54 :: 		TRISIO1_bit= 1;
	BSF        TRISIO1_bit+0, 1
;UPL.c,55 :: 		TRISIO0_bit = 1;
	BSF        TRISIO0_bit+0, 0
;UPL.c,56 :: 		data_pin = 0;
	BCF        GP5_bit+0, 5
;UPL.c,57 :: 		strobe_pin = 0;
	BCF        GP2_bit+0, 2
;UPL.c,58 :: 		clock_pin = 0;
	BCF        GP4_bit+0, 4
;UPL.c,59 :: 		adc_init();          //Initiate internal ADC module
	CALL       _ADC_Init+0
;UPL.c,60 :: 		delay_ms(100);       //Wait of some time
	MOVLW      2
	MOVWF      R11+0
	MOVLW      4
	MOVWF      R12+0
	MOVLW      186
	MOVWF      R13+0
L_UPL_setup3:
	DECFSZ     R13+0, 1
	GOTO       L_UPL_setup3
	DECFSZ     R12+0, 1
	GOTO       L_UPL_setup3
	DECFSZ     R11+0, 1
	GOTO       L_UPL_setup3
	NOP
;UPL.c,61 :: 		}
L_end_setup:
	RETURN
; end of UPL_setup

UPL_test_display:

;UPL.c,64 :: 		static void test_display(void)
;UPL.c,66 :: 		unsigned short test = 0;
	CLRF       UPL_test_display_test_L0+0
;UPL.c,67 :: 		while(test<3)                       //Test seven segment display
L_UPL_test_display4:
	MOVLW      3
	SUBWF      UPL_test_display_test_L0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_UPL_test_display5
;UPL.c,69 :: 		display(disp[test]);   //Put called symbol on display
	MOVF       UPL_test_display_test_L0+0, 0
	ADDLW      _disp+0
	MOVWF      R0+0
	MOVLW      hi_addr(_disp+0)
	BTFSC      STATUS+0, 0
	ADDLW      1
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      ___DoICPAddr+0
	MOVF       R0+1, 0
	MOVWF      ___DoICPAddr+1
	CALL       _____DoICP+0
	MOVWF      FARG_display_val+0
	CALL       _display+0
;UPL.c,70 :: 		delay_ms(400);         //Wait for some time
	MOVLW      5
	MOVWF      R11+0
	MOVLW      15
	MOVWF      R12+0
	MOVLW      241
	MOVWF      R13+0
L_UPL_test_display6:
	DECFSZ     R13+0, 1
	GOTO       L_UPL_test_display6
	DECFSZ     R12+0, 1
	GOTO       L_UPL_test_display6
	DECFSZ     R11+0, 1
	GOTO       L_UPL_test_display6
;UPL.c,71 :: 		test++;                //Continue test
	INCF       UPL_test_display_test_L0+0, 1
;UPL.c,72 :: 		}
	GOTO       L_UPL_test_display4
L_UPL_test_display5:
;UPL.c,73 :: 		display(disp[3]);                   //Turn off display
	CLRF       FARG_display_val+0
	CALL       _display+0
;UPL.c,74 :: 		delay_ms(300);                      // Wait for some time
	MOVLW      4
	MOVWF      R11+0
	MOVLW      12
	MOVWF      R12+0
	MOVLW      51
	MOVWF      R13+0
L_UPL_test_display7:
	DECFSZ     R13+0, 1
	GOTO       L_UPL_test_display7
	DECFSZ     R12+0, 1
	GOTO       L_UPL_test_display7
	DECFSZ     R11+0, 1
	GOTO       L_UPL_test_display7
	NOP
	NOP
;UPL.c,75 :: 		}
L_end_test_display:
	RETURN
; end of UPL_test_display

UPL_test_supply:

;UPL.c,78 :: 		static void test_supply(void)
;UPL.c,80 :: 		register float supply = 0;
	CLRF       UPL_test_supply_supply_L0+0
	CLRF       UPL_test_supply_supply_L0+1
	CLRF       UPL_test_supply_supply_L0+2
	CLRF       UPL_test_supply_supply_L0+3
;UPL.c,81 :: 		supply = adc_avg(1);                //Take the average of supply voltage
	MOVLW      1
	MOVWF      FARG_adc_avg_ch+0
	CALL       _adc_avg+0
	MOVF       R0+0, 0
	MOVWF      UPL_test_supply_supply_L0+0
	MOVF       R0+1, 0
	MOVWF      UPL_test_supply_supply_L0+1
	MOVF       R0+2, 0
	MOVWF      UPL_test_supply_supply_L0+2
	MOVF       R0+3, 0
	MOVWF      UPL_test_supply_supply_L0+3
;UPL.c,82 :: 		delay_ms(150);                      //Wait for some time
	MOVLW      2
	MOVWF      R11+0
	MOVLW      134
	MOVWF      R12+0
	MOVLW      153
	MOVWF      R13+0
L_UPL_test_supply8:
	DECFSZ     R13+0, 1
	GOTO       L_UPL_test_supply8
	DECFSZ     R12+0, 1
	GOTO       L_UPL_test_supply8
	DECFSZ     R11+0, 1
	GOTO       L_UPL_test_supply8
;UPL.c,83 :: 		if(((supply >= 4.75) && (supply <= 5.25)))   //TTL convention test
	MOVLW      0
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	MOVLW      24
	MOVWF      R4+2
	MOVLW      129
	MOVWF      R4+3
	MOVF       UPL_test_supply_supply_L0+0, 0
	MOVWF      R0+0
	MOVF       UPL_test_supply_supply_L0+1, 0
	MOVWF      R0+1
	MOVF       UPL_test_supply_supply_L0+2, 0
	MOVWF      R0+2
	MOVF       UPL_test_supply_supply_L0+3, 0
	MOVWF      R0+3
	CALL       _Compare_Double+0
	MOVLW      1
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_UPL_test_supply11
	MOVF       UPL_test_supply_supply_L0+0, 0
	MOVWF      R4+0
	MOVF       UPL_test_supply_supply_L0+1, 0
	MOVWF      R4+1
	MOVF       UPL_test_supply_supply_L0+2, 0
	MOVWF      R4+2
	MOVF       UPL_test_supply_supply_L0+3, 0
	MOVWF      R4+3
	MOVLW      0
	MOVWF      R0+0
	MOVLW      0
	MOVWF      R0+1
	MOVLW      40
	MOVWF      R0+2
	MOVLW      129
	MOVWF      R0+3
	CALL       _Compare_Double+0
	MOVLW      1
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_UPL_test_supply11
L_UPL_test_supply34:
;UPL.c,85 :: 		high_level = 2.2;
	MOVLW      205
	MOVWF      _high_level+0
	MOVLW      204
	MOVWF      _high_level+1
	MOVLW      12
	MOVWF      _high_level+2
	MOVLW      128
	MOVWF      _high_level+3
;UPL.c,86 :: 		low_level = 0.8;
	MOVLW      205
	MOVWF      _low_level+0
	MOVLW      204
	MOVWF      _low_level+1
	MOVLW      76
	MOVWF      _low_level+2
	MOVLW      126
	MOVWF      _low_level+3
;UPL.c,87 :: 		}                                            //CMOS convention test
	GOTO       L_UPL_test_supply12
L_UPL_test_supply11:
;UPL.c,90 :: 		high_level = (supply*0.67);
	MOVF       UPL_test_supply_supply_L0+0, 0
	MOVWF      R0+0
	MOVF       UPL_test_supply_supply_L0+1, 0
	MOVWF      R0+1
	MOVF       UPL_test_supply_supply_L0+2, 0
	MOVWF      R0+2
	MOVF       UPL_test_supply_supply_L0+3, 0
	MOVWF      R0+3
	MOVLW      31
	MOVWF      R4+0
	MOVLW      133
	MOVWF      R4+1
	MOVLW      43
	MOVWF      R4+2
	MOVLW      126
	MOVWF      R4+3
	CALL       _Mul_32x32_FP+0
	MOVF       R0+0, 0
	MOVWF      _high_level+0
	MOVF       R0+1, 0
	MOVWF      _high_level+1
	MOVF       R0+2, 0
	MOVWF      _high_level+2
	MOVF       R0+3, 0
	MOVWF      _high_level+3
;UPL.c,91 :: 		low_level = (supply*0.33);
	MOVF       UPL_test_supply_supply_L0+0, 0
	MOVWF      R0+0
	MOVF       UPL_test_supply_supply_L0+1, 0
	MOVWF      R0+1
	MOVF       UPL_test_supply_supply_L0+2, 0
	MOVWF      R0+2
	MOVF       UPL_test_supply_supply_L0+3, 0
	MOVWF      R0+3
	MOVLW      195
	MOVWF      R4+0
	MOVLW      245
	MOVWF      R4+1
	MOVLW      40
	MOVWF      R4+2
	MOVLW      125
	MOVWF      R4+3
	CALL       _Mul_32x32_FP+0
	MOVF       R0+0, 0
	MOVWF      _low_level+0
	MOVF       R0+1, 0
	MOVWF      _low_level+1
	MOVF       R0+2, 0
	MOVWF      _low_level+2
	MOVF       R0+3, 0
	MOVWF      _low_level+3
;UPL.c,92 :: 		}                                            //Wait for a while
L_UPL_test_supply12:
;UPL.c,93 :: 		delay_ms(50);
	MOVLW      130
	MOVWF      R12+0
	MOVLW      221
	MOVWF      R13+0
L_UPL_test_supply13:
	DECFSZ     R13+0, 1
	GOTO       L_UPL_test_supply13
	DECFSZ     R12+0, 1
	GOTO       L_UPL_test_supply13
	NOP
	NOP
;UPL.c,94 :: 		}
L_end_test_supply:
	RETURN
; end of UPL_test_supply

_display:

;UPL.c,97 :: 		void display(unsigned char val)
;UPL.c,99 :: 		unsigned short clk = 0;
	CLRF       display_clk_L0+0
;UPL.c,101 :: 		strobe_pin = 0;                               //Hold strobe pin low
	BCF        GP2_bit+0, 2
;UPL.c,102 :: 		for(clk = 0; clk < 8; clk++)                  //Do following job eight times
	CLRF       display_clk_L0+0
L_display14:
	MOVLW      8
	SUBWF      display_clk_L0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_display15
;UPL.c,104 :: 		d = (0x80 & val);                         //Read the MSB of val
	MOVLW      128
	ANDWF      FARG_display_val+0, 0
	MOVWF      R1+0
;UPL.c,105 :: 		if(d == 0)                                //If the MSB is zero
	MOVF       R1+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_display17
;UPL.c,107 :: 		data_pin = 0;                        //then send 0
	BCF        GP5_bit+0, 5
;UPL.c,108 :: 		}
	GOTO       L_display18
L_display17:
;UPL.c,111 :: 		data_pin = 1;
	BSF        GP5_bit+0, 5
;UPL.c,112 :: 		}
L_display18:
;UPL.c,113 :: 		clock_pin = 1;                            //Pull clock pin high
	BSF        GP4_bit+0, 4
;UPL.c,114 :: 		delay_ms(1);                              //Wait for a while
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_display19:
	DECFSZ     R13+0, 1
	GOTO       L_display19
	DECFSZ     R12+0, 1
	GOTO       L_display19
	NOP
	NOP
;UPL.c,115 :: 		val = val << 1;                           //Left shift val
	RLF        FARG_display_val+0, 1
	BCF        FARG_display_val+0, 0
;UPL.c,116 :: 		clock_pin = 0;                            //Hold clock pin low
	BCF        GP4_bit+0, 4
;UPL.c,117 :: 		delay_ms(1);                              //Wait for a while
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_display20:
	DECFSZ     R13+0, 1
	GOTO       L_display20
	DECFSZ     R12+0, 1
	GOTO       L_display20
	NOP
	NOP
;UPL.c,102 :: 		for(clk = 0; clk < 8; clk++)                  //Do following job eight times
	INCF       display_clk_L0+0, 1
;UPL.c,118 :: 		}
	GOTO       L_display14
L_display15:
;UPL.c,119 :: 		strobe_pin = 1;                               //Pull strobe pin high
	BSF        GP2_bit+0, 2
;UPL.c,120 :: 		delay_ms(1);                                  //Wait for a while
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_display21:
	DECFSZ     R13+0, 1
	GOTO       L_display21
	DECFSZ     R12+0, 1
	GOTO       L_display21
	NOP
	NOP
;UPL.c,121 :: 		}
L_end_display:
	RETURN
; end of _display

_adc_avg:

;UPL.c,124 :: 		float adc_avg(unsigned char ch)
;UPL.c,126 :: 		register unsigned int temp = 0;
	CLRF       adc_avg_temp_L0+0
	CLRF       adc_avg_temp_L0+1
	CLRF       adc_avg_samples_L0+0
;UPL.c,129 :: 		delay_ms(1);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_adc_avg22:
	DECFSZ     R13+0, 1
	GOTO       L_adc_avg22
	DECFSZ     R12+0, 1
	GOTO       L_adc_avg22
	NOP
	NOP
;UPL.c,130 :: 		for(samples = 1; samples <= 16; samples += 1)   //Take 16 ADC samples
	MOVLW      1
	MOVWF      adc_avg_samples_L0+0
L_adc_avg23:
	MOVF       adc_avg_samples_L0+0, 0
	SUBLW      16
	BTFSS      STATUS+0, 0
	GOTO       L_adc_avg24
;UPL.c,132 :: 		temp = adc_read(ch);            //Read assigned ADC
	MOVF       FARG_adc_avg_ch+0, 0
	MOVWF      FARG_ADC_Read_channel+0
	CALL       _ADC_Read+0
	MOVF       R0+0, 0
	MOVWF      adc_avg_temp_L0+0
	MOVF       R0+1, 0
	MOVWF      adc_avg_temp_L0+1
;UPL.c,133 :: 		temp += temp;                   //channel data and
	MOVF       R0+0, 0
	ADDWF      R0+0, 0
	MOVWF      adc_avg_temp_L0+0
	MOVF       R0+1, 0
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      R0+1, 0
	MOVWF      adc_avg_temp_L0+1
;UPL.c,134 :: 		delay_us(25);                   //store temporarily
	MOVLW      16
	MOVWF      R13+0
L_adc_avg26:
	DECFSZ     R13+0, 1
	GOTO       L_adc_avg26
	NOP
;UPL.c,130 :: 		for(samples = 1; samples <= 16; samples += 1)   //Take 16 ADC samples
	INCF       adc_avg_samples_L0+0, 1
;UPL.c,135 :: 		}
	GOTO       L_adc_avg23
L_adc_avg24:
;UPL.c,136 :: 		avg = (temp * 5.0);                            //Convert to readable
	MOVF       adc_avg_temp_L0+0, 0
	MOVWF      R0+0
	MOVF       adc_avg_temp_L0+1, 0
	MOVWF      R0+1
	CALL       _Word2Double+0
	MOVLW      0
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	MOVLW      32
	MOVWF      R4+2
	MOVLW      129
	MOVWF      R4+3
	CALL       _Mul_32x32_FP+0
;UPL.c,137 :: 		avg /= 1023.0;                                 //value other than count
	MOVLW      0
	MOVWF      R4+0
	MOVLW      192
	MOVWF      R4+1
	MOVLW      127
	MOVWF      R4+2
	MOVLW      136
	MOVWF      R4+3
	CALL       _Div_32x32_FP+0
;UPL.c,138 :: 		avg *= 10.0;                                   //Take voltage divider
	MOVLW      0
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	MOVLW      32
	MOVWF      R4+2
	MOVLW      130
	MOVWF      R4+3
	CALL       _Mul_32x32_FP+0
;UPL.c,139 :: 		avg /= 16.0;                                   //and number of samples
	MOVLW      0
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	MOVLW      0
	MOVWF      R4+2
	MOVLW      131
	MOVWF      R4+3
	CALL       _Div_32x32_FP+0
;UPL.c,140 :: 		return avg;                                    //into account
;UPL.c,141 :: 		}
L_end_adc_avg:
	RETURN
; end of _adc_avg

_check_logic:

;UPL.c,144 :: 		void check_logic(void)
;UPL.c,146 :: 		register float vin = 0;
	CLRF       check_logic_vin_L0+0
	CLRF       check_logic_vin_L0+1
	CLRF       check_logic_vin_L0+2
	CLRF       check_logic_vin_L0+3
;UPL.c,147 :: 		vin = adc_avg(0);                   //Read logic input channel
	CLRF       FARG_adc_avg_ch+0
	CALL       _adc_avg+0
	MOVF       R0+0, 0
	MOVWF      check_logic_vin_L0+0
	MOVF       R0+1, 0
	MOVWF      check_logic_vin_L0+1
	MOVF       R0+2, 0
	MOVWF      check_logic_vin_L0+2
	MOVF       R0+3, 0
	MOVWF      check_logic_vin_L0+3
;UPL.c,148 :: 		delay_ms(20);                       //Wait for some time
	MOVLW      52
	MOVWF      R12+0
	MOVLW      241
	MOVWF      R13+0
L_check_logic27:
	DECFSZ     R13+0, 1
	GOTO       L_check_logic27
	DECFSZ     R12+0, 1
	GOTO       L_check_logic27
	NOP
	NOP
;UPL.c,149 :: 		if(vin >= high_level)               //Check if it is high
	MOVF       _high_level+0, 0
	MOVWF      R4+0
	MOVF       _high_level+1, 0
	MOVWF      R4+1
	MOVF       _high_level+2, 0
	MOVWF      R4+2
	MOVF       _high_level+3, 0
	MOVWF      R4+3
	MOVF       check_logic_vin_L0+0, 0
	MOVWF      R0+0
	MOVF       check_logic_vin_L0+1, 0
	MOVWF      R0+1
	MOVF       check_logic_vin_L0+2, 0
	MOVWF      R0+2
	MOVF       check_logic_vin_L0+3, 0
	MOVWF      R0+3
	CALL       _Compare_Double+0
	MOVLW      1
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_check_logic28
;UPL.c,151 :: 		display(disp[2]);               //Send 'H' to display
	MOVLW      118
	MOVWF      FARG_display_val+0
	CALL       _display+0
;UPL.c,152 :: 		}
	GOTO       L_check_logic29
L_check_logic28:
;UPL.c,153 :: 		else if(vin <= low_level)           //Check if it is low
	MOVF       check_logic_vin_L0+0, 0
	MOVWF      R4+0
	MOVF       check_logic_vin_L0+1, 0
	MOVWF      R4+1
	MOVF       check_logic_vin_L0+2, 0
	MOVWF      R4+2
	MOVF       check_logic_vin_L0+3, 0
	MOVWF      R4+3
	MOVF       _low_level+0, 0
	MOVWF      R0+0
	MOVF       _low_level+1, 0
	MOVWF      R0+1
	MOVF       _low_level+2, 0
	MOVWF      R0+2
	MOVF       _low_level+3, 0
	MOVWF      R0+3
	CALL       _Compare_Double+0
	MOVLW      1
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_check_logic30
;UPL.c,155 :: 		display(disp[0]);               //Send 'L' to display
	MOVLW      56
	MOVWF      FARG_display_val+0
	CALL       _display+0
;UPL.c,156 :: 		}
	GOTO       L_check_logic31
L_check_logic30:
;UPL.c,159 :: 		display(disp[1]);               //Toggle and send 'U' to display
	MOVLW      62
	MOVWF      FARG_display_val+0
	CALL       _display+0
;UPL.c,160 :: 		delay_ms(400);
	MOVLW      5
	MOVWF      R11+0
	MOVLW      15
	MOVWF      R12+0
	MOVLW      241
	MOVWF      R13+0
L_check_logic32:
	DECFSZ     R13+0, 1
	GOTO       L_check_logic32
	DECFSZ     R12+0, 1
	GOTO       L_check_logic32
	DECFSZ     R11+0, 1
	GOTO       L_check_logic32
;UPL.c,161 :: 		display(disp[3]);
	CLRF       FARG_display_val+0
	CALL       _display+0
;UPL.c,162 :: 		delay_ms(400);
	MOVLW      5
	MOVWF      R11+0
	MOVLW      15
	MOVWF      R12+0
	MOVLW      241
	MOVWF      R13+0
L_check_logic33:
	DECFSZ     R13+0, 1
	GOTO       L_check_logic33
	DECFSZ     R12+0, 1
	GOTO       L_check_logic33
	DECFSZ     R11+0, 1
	GOTO       L_check_logic33
;UPL.c,163 :: 		}
L_check_logic31:
L_check_logic29:
;UPL.c,164 :: 		}
L_end_check_logic:
	RETURN
; end of _check_logic
