#line 1 "C:/Users/Shahriyar/Desktop/Universal Logic Probe/MikroC Code/UPL.c"
#line 18 "C:/Users/Shahriyar/Desktop/Universal Logic Probe/MikroC Code/UPL.c"
float high_level = 0.0;
float low_level = 0.0;
const unsigned short disp [4] =
{0x38, 0x3E, 0x76, 0x00};




static void setup(void);
static void test_display(void);
static void test_supply(void);
void display(unsigned char val);
float adc_avg(unsigned char ch);
void check_logic(void);


void main(void)
{
 setup();
 test_supply();
 test_display();

 for(;;)
 {
 check_logic();
 }
}


static void setup(void)
{

 TRISIO5_bit = 0;
 TRISIO4_bit = 0;
 TRISIO3_bit = 1;
 TRISIO2_bit = 0;
 TRISIO1_bit= 1;
 TRISIO0_bit = 1;
  GP5_bit  = 0;
  GP2_bit  = 0;
  GP4_bit  = 0;
 adc_init();
 delay_ms(100);
}


static void test_display(void)
{
 unsigned short test = 0;
 while(test<3)
 {
 display(disp[test]);
 delay_ms(400);
 test++;
 }
 display(disp[3]);
 delay_ms(300);
}


static void test_supply(void)
{
 register float supply = 0;
 supply = adc_avg(1);
 delay_ms(150);
 if(((supply >= 4.75) && (supply <= 5.25)))
 {
 high_level = 2.2;
 low_level = 0.8;
 }
 else
 {
 high_level = (supply*0.67);
 low_level = (supply*0.33);
 }
 delay_ms(50);
}


void display(unsigned char val)
{
 unsigned short clk = 0;
 unsigned short d = 0;
  GP2_bit  = 0;
 for(clk = 0; clk < 8; clk++)
 {
 d = (0x80 & val);
 if(d == 0)
 {
  GP5_bit  = 0;
 }
 else
 {
  GP5_bit  = 1;
 }
  GP4_bit  = 1;
 delay_ms(1);
 val = val << 1;
  GP4_bit  = 0;
 delay_ms(1);
 }
  GP2_bit  = 1;
 delay_ms(1);
}


float adc_avg(unsigned char ch)
{
 register unsigned int temp = 0;
 unsigned short samples = 0;
 register float avg = 0;
 delay_ms(1);
 for(samples = 1; samples <= 16; samples += 1)
 {
 temp = adc_read(ch);
 temp += temp;
 delay_us(25);
 }
 avg = (temp * 5.0);
 avg /= 1023.0;
 avg *= 10.0;
 avg /= 16.0;
 return avg;
}


void check_logic(void)
{
 register float vin = 0;
 vin = adc_avg(0);
 delay_ms(20);
 if(vin >= high_level)
 {
 display(disp[2]);
 }
 else if(vin <= low_level)
 {
 display(disp[0]);
 }
 else
 {
 display(disp[1]);
 delay_ms(400);
 display(disp[3]);
 delay_ms(400);
 }
}
